glibmm: Gio::DBus::Interface Class Reference

glibmm 2.32.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gio::DBus::Interface Class Reference

Interface - Base type for D-Bus interfaces. More...

`#include <giomm/dbusinterface.h>`

Inheritance diagram for Gio::DBus::Interface:
[legend]

List of all members.

## Public Member Functions
virtual | ~Interface ()
GDBusInterface* | gobj ()
| Provides access to the underlying C GObject.
const GDBusInterface* | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< InterfaceInfo > | get_info ()
| Gets D-Bus introspection information for the D-Bus interface implemented by interface.
Glib::RefPtr< const InterfaceInfo > | get_info () const
| Gets D-Bus introspection information for the D-Bus interface implemented by interface.
Glib::RefPtr< Gio::DBus::Object > | get_object ()
| Gets the DBusObject that interface belongs to, if any.
Glib::RefPtr< const Gio::DBus::Object > | get_object () const
| Gets the DBusObject that interface belongs to, if any.
Glib::RefPtr< Gio::DBus::Object > | dup_object ()
| Gets the DBusObject that interface belongs to, if any.
Glib::RefPtr< const Gio::DBus::Object > | dup_object () const
| Gets the DBusObject that interface belongs to, if any.
void | set_object (const Glib::RefPtr< Gio::DBus::Object >& object)
| Sets the DBusObject for interface to object.
virtual Glib::RefPtr < InterfaceInfo > | get_info_vfunc () const
virtual Glib::RefPtr < Gio::DBus::Object > | get_object_vfunc () const
virtual void | set_object_vfunc (const Glib::RefPtr< Gio::DBus::Object >& object)
virtual Glib::RefPtr < Gio::DBus::Object > | dup_object_vfunc () const
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes.
| Interface (GObject* castitem)
| Called by constructors of derived classes.
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)

## Protected Member Functions
| Interface ()
| You should derive from this class to use it.

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::DBus::Interface > | wrap (GDBusInterface* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Interface - Base type for D-Bus interfaces.

The Interface type is the base type for D-Bus interfaces both on the service side (see InterfaceSkeleton) and client side (see Proxy).

Since glibmm 2.34:

## Constructor & Destructor Documentation

Gio::DBus::Interface::Interface | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::DBus::Interface::~Interface | ( |  | ) |
| virtual

Reimplemented from Glib::Interface.

## Member Function Documentation

static void Gio::DBus::Interface::add_interface | ( | GType | gtype_implementer | ) |
| static

Glib::RefPtr<Gio::DBus::Object> Gio::DBus::Interface::dup_object | ( |  | ) |

Gets the DBusObject that interface belongs to, if any.

Since glibmm 2.32:

Returns:
  A DBusObject or `0`. The returned reference should be freed with Glib::object_unref().

Glib::RefPtr<const Gio::DBus::Object> Gio::DBus::Interface::dup_object | ( |  | ) | const

Gets the DBusObject that interface belongs to, if any.

Since glibmm 2.32:

Returns:
  A DBusObject or `0`. The returned reference should be freed with Glib::object_unref().

virtual Glib::RefPtr<Gio::DBus::Object> Gio::DBus::Interface::dup_object_vfunc | ( |  | ) | const
| virtual

Glib::RefPtr<InterfaceInfo> Gio::DBus::Interface::get_info | ( |  | ) |

Gets D-Bus introspection information for the D-Bus interface implemented by interface.

Since glibmm 2.30:

Returns:
  A DBusInterfaceInfo. Do not free.

Glib::RefPtr<const InterfaceInfo> Gio::DBus::Interface::get_info | ( |  | ) | const

Gets D-Bus introspection information for the D-Bus interface implemented by interface.

Since glibmm 2.30:

Returns:
  A DBusInterfaceInfo. Do not free.

virtual Glib::RefPtr<InterfaceInfo> Gio::DBus::Interface::get_info_vfunc | ( |  | ) | const
| virtual

Glib::RefPtr<Gio::DBus::Object> Gio::DBus::Interface::get_object | ( |  | ) |

Gets the DBusObject that interface belongs to, if any.

<warning>It is not safe to use the returned object if interface or the returned object is being used from other threads. See g_dbus_interface_dup_object() for a thread-safe alternative.</warning>

Since glibmm 2.30:

Returns:
  A DBusObject or `0`. The returned reference belongs to interface and should not be freed.

Glib::RefPtr<const Gio::DBus::Object> Gio::DBus::Interface::get_object | ( |  | ) | const

Gets the DBusObject that interface belongs to, if any.

<warning>It is not safe to use the returned object if interface or the returned object is being used from other threads. See g_dbus_interface_dup_object() for a thread-safe alternative.</warning>

Since glibmm 2.30:

Returns:
  A DBusObject or `0`. The returned reference belongs to interface and should not be freed.

virtual Glib::RefPtr<Gio::DBus::Object> Gio::DBus::Interface::get_object_vfunc | ( |  | ) | const
| virtual

GDBusInterface* Gio::DBus::Interface::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

const GDBusInterface* Gio::DBus::Interface::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

void Gio::DBus::Interface::set_object | ( | const Glib::RefPtr< Gio::DBus::Object >& | object | ) |

Sets the DBusObject for interface to object.

Note that interface will hold a weak reference to object.

Since glibmm 2.30:

Parameters:

  object | A DBusObject or `0`.

virtual void Gio::DBus::Interface::set_object_vfunc | ( | const Glib::RefPtr< Gio::DBus::Object >& | object | ) |
| virtual

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::Interface > wrap | ( | GDBusInterface * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.